
PImage[] img = new PImage[6];
int w = 32;
int h = 32;     
int nx, ny;

String[][] arStage  = {
    {"#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#"},
    {"#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#"},
    {"#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#"},
    {"#","#","#","#","#"," "," "," ","#","#","#","#","#","#","#","#","#","#","#","#"},
    {"#","#","#","#","#","O"," "," ","#","#","#","#","#","#","#","#","#","#","#","#"},
    {"#","#","#","#","#"," "," ","O","#","#","#","#","#","#","#","#","#","#","#","#"},
    {"#","#","#"," "," ","O"," ","O"," ","#","#","#","#","#","#","#","#","#","#","#"},
    {"#","#","#"," ","#"," ","#","#"," ","#","#","#","#","#","#","#","#","#","#","#"},
    {"#"," "," "," ","#"," ","#","#"," ","#","#","#","#","#"," "," ",".",".","#","#"},
    {"#"," ","O"," "," ","O"," "," "," ","a"," "," "," "," "," "," ",".",".","#","#"},
    {"#","#","#","#","#"," ","#","#","#"," ","#"," ","#","#"," "," ",".",".","#","#"},
    {"#","#","#","#","#"," "," "," "," "," ","#","#","#","#","#","#","#","#","#","#"},
    {"#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#"},
    {"#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#"},
    {"#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#"},
    {"#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#"},
    {"#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#"},
    {"#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#","#"},
};
PFont f;

void setup()  {   
  size(640,h*18);
  smooth();

  img[0] = loadImage("wall.jpg");
  img[1] = loadImage("pack.jpg");
  img[2] = loadImage("target.jpg");
  img[3] = loadImage("empty.jpg");
  img[4] = loadImage("man.jpg");
  img[5] = loadImage("123.jpg");
   f = createFont("Batang",12,true); 
   
}   

void draw()  {   
  background(255);
  if(TestEnd() == true)
   {
     background(0);
     textFont(f,48);
      textAlign(CENTER);
      fill(255,0,0);
      image(img[5],0,0);
      text("SUCCESS ^^",width/2,height/2);
      
    }
   else
   {
  int x, y;
  int iBit = 0;

  for (y = 0; y < 18; y++)
  {
      for (x = 0; x < 20; x++)
      {
          if(arStage[y][x] == "#")
                  iBit = 0;
          else if(arStage[y][x] == "O")
                  iBit = 1;
          else if(arStage[y][x] == ".")
                iBit = 2;
          else if(arStage[y][x] == " ")
                iBit = 3;
          
          if (arStage[y][x] == "a")
          {
              nx = x;
              ny = y;
              arStage[y][x] = " ";
          }  
            image(img[iBit], x * w, y * h);
       }
          
   }
   image(img[4],nx*w,ny*h);
   }
  
} 

void keyPressed()
{
  
  int dx =0, dy =0;
  if(key == 'a') 
    dx = -1;
  else if(key == 'd')
    dx = 1;
  else if(key == 'w')
    dy = -1;
  else if(key == 's')
    dy = 1;
if (arStage[ny + dy][nx + dx] != "#")
  {
      if (arStage[ny + dy][nx + dx] == "O")
      {
          if (arStage[ny + dy * 2][nx + dx * 2] == " " || arStage[ny + dy * 2][nx + dx * 2] == ".")
          {
              if (arStage[ny + dy][nx + dx] == ".")
              {
                  arStage[ny + dy][nx + dx] = ".";
              }
              else
              {
                  arStage[ny + dy][nx + dx] = " ";
              }
              arStage[ny + dy * 2][nx + dx * 2] = "O";
          }
          else
          {
              return;
          }
      }
      nx += dx;
      ny += dy;
  }
  
}

boolean TestEnd()
{
    int x, y;

    for (y = 0; y < 18; y++)
    {
        for (x = 0; x < 20; x++)
        {
            if (arStage[y][x] == "." && arStage[y][x] != "O")
            {
                return false;
            }
        }
    }
    return true;
}
